library free_storage;

import 'dart:convert';
import 'package:shared_preferences/shared_preferences.dart';

class FreeStorage {
  static write(String s) async {
    SharedPreferences prefs = await SharedPreferences.getInstance();
    prefs.setString('data', s);
  }

  static add(Map s) async {
    String reading = await read();
    if (reading.isEmpty || reading.length == 0) {
      String toS = jsonEncode(s);
      write('''{"data":[$toS]}''');
    } else {
      Map map = jsonDecode(reading);
      map['data'].add(s);
      Map edite = map;
      String toS = jsonEncode(edite);
      write(toS);
    }
  }

  static Future<List> get getdataList async {
    String reading = await read();
    if (reading.isNotEmpty) {
      Map map = jsonDecode(reading);
      List tol = map['data'];

      return tol;
    } else {
      return [];
    }
  }

  static removeRow(int i) async {
    String reading = await read();
    Map map = jsonDecode(reading);
    if (reading.isNotEmpty && i < map['data'].length) {
      map['data'].removeAt(i);
      String toS = jsonEncode(map);
      write(toS);
    }
  }

  static removeListRow(List<int> indexes) async {
    String reading = await read();
    if (reading.isNotEmpty) {
      Map map = jsonDecode(reading);
      for (var i = 0; i < indexes.length; i++) {
        map['data'].removeAt(indexes[i]);
      }
      String toS = jsonEncode(map);
      write(toS);
    }
  }

  static copyAddPast(int i) async {
    String reading = await read();
    if (reading.isNotEmpty) {
      Map maps = jsonDecode(reading);
      maps['data'].add(maps['data'][i]);
      String toS = jsonEncode(maps);
      write(toS);
    }
  }

  static moveIteam(int oldI, int newI) async {
    String reading = await read();
    if (reading.isNotEmpty) {
      Map<String, dynamic> maps = jsonDecode(reading);
      if (newI > oldI) {
        newI -= 1;
      }
      final element = maps['data'].removeAt(oldI);
      maps['data'].insert(newI, element);
      String toS = jsonEncode(maps);
      write(toS);
    }
  }

  static switchTwoItems(int oldI, int newI) async {
    String reading = await read();
    if (reading.isNotEmpty) {
      Map<String, dynamic> maps = jsonDecode(reading);
      Map<String, dynamic> move = maps['data'][oldI];
      maps['data'][oldI] = maps['data'][newI];
      maps['data'][newI] = move;
      String toS = jsonEncode(maps);
      write(toS);
    }
  }

  static editeRow(int i, Map map) async {
    String reading = await read();
    if (reading.isNotEmpty) {
      Map maps = jsonDecode(reading);
      maps['data'][i] = map;
      String toS = jsonEncode(maps);
      write(toS);
    }
  }

  static editeFildOrFildes(int i, Map<String, dynamic> map) async {
    String reading = await read();
    if (reading.isNotEmpty) {
      Map<String, dynamic> maps = jsonDecode(reading);
      maps['data'][i].addAll(map);
      String toS = jsonEncode(maps);
      write(toS);
    }
  }

  static Future<String> read() async {
    SharedPreferences prefs = await SharedPreferences.getInstance();
    final myString = prefs.getString('data') ?? '';
    return myString;
  }

  static removeAllData() async {
    write('');
  }

  static removeRootData() async {
    SharedPreferences prefs = await SharedPreferences.getInstance();
    prefs.remove('data');
  }
}
